/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.29                 *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Detects presence of magnetic field
	/// </summary>
	public class BrickletHallEffect : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 240;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Hall Effect Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_VALUE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_EDGE_COUNT_CONFIG = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT_CONFIG = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_EDGE_INTERRUPT = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_INTERRUPT = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_EDGE_COUNT_CALLBACK_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_EDGE_COUNT_CALLBACK_PERIOD = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_EDGE_INTERRUPT = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_EDGE_COUNT = 10;


		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_RISING = 0;

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_FALLING = 1;

		/// <summary>
		/// </summary>
		public const byte EDGE_TYPE_BOTH = 2;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletHallEffect.SetEdgeCountCallbackPeriod"/>. The parameters are the
		///  current count and the current value (see <see cref="Tinkerforge.BrickletHallEffect.GetValue"/> and
		///  <see cref="Tinkerforge.BrickletHallEffect.GetEdgeCount"/>).
		///  
		///  The <see cref="Tinkerforge.BrickletHallEffect.EdgeCountCallback"/> callback is only triggered if the count or value changed
		///  since the last triggering.
		/// </summary>
		public event EdgeCountEventHandler EdgeCountCallback;
		/// <summary>
		/// </summary>
		public delegate void EdgeCountEventHandler(BrickletHallEffect sender, long count, bool value);

		/// <summary>
		/// </summary>
		public event EdgeCountEventHandler EdgeCount // for backward compatibility
		{
			add { EdgeCountCallback += value; }
			remove { EdgeCountCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletHallEffect(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_EDGE_COUNT] = new CallbackWrapper(OnEdgeCountCallback);


			responseExpected[FUNCTION_GET_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_EDGE_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_EDGE_COUNT_CONFIG] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_EDGE_COUNT_CONFIG] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_EDGE_INTERRUPT] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_EDGE_INTERRUPT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_EDGE_COUNT_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_EDGE_COUNT_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_EDGE_INTERRUPT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns *true* if a magnetic field of 3.5 millitesla or greater is detected.
		/// </summary>
		public bool GetValue()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_VALUE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the current value of the edge counter. You can configure
		///  edge type (rising, falling, both) that is counted with
		///  <see cref="Tinkerforge.BrickletHallEffect.SetEdgeCountConfig"/>.
		///  
		///  If you set the reset counter to *true*, the count is set back to 0
		///  directly after it is read.
		/// </summary>
		public long GetEdgeCount(bool resetCounter)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_EDGE_COUNT);
			LEConverter.To((bool)resetCounter, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  The edge type parameter configures if rising edges, falling edges or
		///  both are counted. Possible edge types are:
		///  
		///  * 0 = rising
		///  * 1 = falling
		///  * 2 = both
		///  
		///  A magnetic field of 3.5 millitesla or greater causes a falling edge and a
		///  magnetic field of 2.5 millitesla or smaller causes a rising edge.
		///  
		///  If a magnet comes near the Bricklet the signal goes low (falling edge), if
		///  a magnet is removed from the vicinity the signal goes high (rising edge).
		///  
		///  Configuring an edge counter resets its value to 0.
		///  
		///  If you don't know what any of this means, just leave it at default. The
		///  default configuration is very likely OK for you.
		/// </summary>
		public void SetEdgeCountConfig(byte edgeType, byte debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_EDGE_COUNT_CONFIG);
			LEConverter.To((byte)edgeType, 8, request);
			LEConverter.To((byte)debounce, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the edge type and debounce time as set by <see cref="Tinkerforge.BrickletHallEffect.SetEdgeCountConfig"/>.
		/// </summary>
		public void GetEdgeCountConfig(out byte edgeType, out byte debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_EDGE_COUNT_CONFIG);

			byte[] response = SendRequest(request, 10);

			edgeType = LEConverter.ByteFrom(8, response);
			debounce = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Sets the number of edges until an interrupt is invoked.
		///  
		///  If *edges* is set to n, an interrupt is invoked for every n-th detected edge.
		///  
		///  If *edges* is set to 0, the interrupt is disabled.
		/// </summary>
		public void SetEdgeInterrupt(long edges)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_EDGE_INTERRUPT);
			LEConverter.To((int)edges, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the edges as set by <see cref="Tinkerforge.BrickletHallEffect.SetEdgeInterrupt"/>.
		/// </summary>
		public long GetEdgeInterrupt()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_EDGE_INTERRUPT);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletHallEffect.EdgeCountCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletHallEffect.EdgeCountCallback"/> callback is only triggered if the edge count has changed
		///  since the last triggering.
		/// </summary>
		public void SetEdgeCountCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_EDGE_COUNT_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletHallEffect.SetEdgeCountCallbackPeriod"/>.
		/// </summary>
		public long GetEdgeCountCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_EDGE_COUNT_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  This callback is triggered every n-th count, as configured with
		///  <see cref="Tinkerforge.BrickletHallEffect.SetEdgeInterrupt"/>. The parameters are the
		///  current count and the current value (see <see cref="Tinkerforge.BrickletHallEffect.GetValue"/> and
		///  <see cref="Tinkerforge.BrickletHallEffect.GetEdgeCount"/>).
		/// </summary>
		public void EdgeInterrupt(out long count, out bool value)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_EDGE_INTERRUPT);

			byte[] response = SendRequest(request, 13);

			count = LEConverter.UIntFrom(8, response);
			value = LEConverter.BoolFrom(12, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnEdgeCountCallback(byte[] response)
		{
			if (response.Length != 13)
			{
				return; // silently ignoring callback with wrong length
			}

			long count = LEConverter.UIntFrom(8, response);
			bool value = LEConverter.BoolFrom(12, response);
			var handler = EdgeCountCallback;

			if (handler != null)
			{
				handler(this, count, value);
			}
		}
	}
}
