/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.29                 *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures soil moisture
	/// </summary>
	public class BrickletMoisture : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 232;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Moisture Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOISTURE_VALUE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MOISTURE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOISTURE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MOISTURE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOISTURE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MOVING_AVERAGE = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MOVING_AVERAGE = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_MOISTURE = 8;

		private const int CALLBACK_MOISTURE_REACHED = 9;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletMoisture.SetMoistureCallbackPeriod"/>. The parameter is the
		///  moisture value of the sensor.
		///  
		///  The <see cref="Tinkerforge.BrickletMoisture.MoistureCallback"/> callback is only triggered if the moisture value has changed
		///  since the last triggering.
		/// </summary>
		public event MoistureEventHandler MoistureCallback;
		/// <summary>
		/// </summary>
		public delegate void MoistureEventHandler(BrickletMoisture sender, int moisture);

		/// <summary>
		/// </summary>
		public event MoistureEventHandler Moisture // for backward compatibility
		{
			add { MoistureCallback += value; }
			remove { MoistureCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletMoisture.SetMoistureCallbackThreshold"/> is reached.
		///  The parameter is the moisture value of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletMoisture.SetDebouncePeriod"/>.
		/// </summary>
		public event MoistureReachedEventHandler MoistureReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void MoistureReachedEventHandler(BrickletMoisture sender, int moisture);

		/// <summary>
		/// </summary>
		public event MoistureReachedEventHandler MoistureReached // for backward compatibility
		{
			add { MoistureReachedCallback += value; }
			remove { MoistureReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletMoisture(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_MOISTURE] = new CallbackWrapper(OnMoistureCallback);
			callbackWrappers[CALLBACK_MOISTURE_REACHED] = new CallbackWrapper(OnMoistureReachedCallback);


			responseExpected[FUNCTION_GET_MOISTURE_VALUE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MOISTURE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_MOISTURE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MOISTURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_MOISTURE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MOVING_AVERAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MOVING_AVERAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the current moisture value.
		///  A small value corresponds to little moisture, a big
		///  value corresponds to much moisture.
		///  
		///  If you want to get the moisture value periodically, it is recommended
		///  to use the <see cref="Tinkerforge.BrickletMoisture.MoistureCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletMoisture.SetMoistureCallbackPeriod"/>.
		/// </summary>
		public int GetMoistureValue()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOISTURE_VALUE);

			byte[] response = SendRequest(request, 10);

			return LEConverter.UShortFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletMoisture.MoistureCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletMoisture.MoistureCallback"/> callback is only triggered if the moisture value has changed
		///  since the last triggering.
		/// </summary>
		public void SetMoistureCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_MOISTURE_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletMoisture.SetMoistureCallbackPeriod"/>.
		/// </summary>
		public long GetMoistureCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOISTURE_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletMoisture.MoistureReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the moisture value is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the moisture value is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the moisture value is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the moisture value is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetMoistureCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_MOISTURE_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((short)min, 9, request);
			LEConverter.To((short)max, 11, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletMoisture.SetMoistureCallbackThreshold"/>.
		/// </summary>
		public void GetMoistureCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOISTURE_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 13);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UShortFrom(9, response);
			max = LEConverter.UShortFrom(11, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletMoisture.MoistureReachedCallback"/>
		///  
		///  is triggered, if the threshold
		///  
		///  * <see cref="Tinkerforge.BrickletMoisture.SetMoistureCallbackThreshold"/>
		///  
		///  keeps being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletMoisture.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
		///  for the moisture value.
		///  
		///  Setting the length to 0 will turn the averaging completely off. With less
		///  averaging, there is more noise on the data.
		/// </summary>
		public void SetMovingAverage(byte average)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_MOVING_AVERAGE);
			LEConverter.To((byte)average, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the length moving average as set by <see cref="Tinkerforge.BrickletMoisture.SetMovingAverage"/>.
		/// </summary>
		public byte GetMovingAverage()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MOVING_AVERAGE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnMoistureCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int moisture = LEConverter.UShortFrom(8, response);
			var handler = MoistureCallback;

			if (handler != null)
			{
				handler(this, moisture);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnMoistureReachedCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			int moisture = LEConverter.UShortFrom(8, response);
			var handler = MoistureReachedCallback;

			if (handler != null)
			{
				handler(this, moisture);
			}
		}
	}
}
