/* ***********************************************************
 * This file was automatically generated on 2021-05-06.      *
 *                                                           *
 * Visual Basic .NET Bindings Version 2.1.29                 *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  360° rotary encoder with push-button
	/// </summary>
	public class BrickletRotaryEncoder : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 236;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Rotary Encoder Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_COUNT = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_COUNT_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_COUNT_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_COUNT_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_COUNT_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_IS_PRESSED = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_COUNT = 8;

		private const int CALLBACK_COUNT_REACHED = 9;

		private const int CALLBACK_PRESSED = 11;

		private const int CALLBACK_RELEASED = 12;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletRotaryEncoder.SetCountCallbackPeriod"/>. The parameter is the count of
		///  the encoder.
		///  
		///  The <see cref="Tinkerforge.BrickletRotaryEncoder.CountCallback"/> callback is only triggered if the count has changed since the
		///  last triggering.
		/// </summary>
		public event CountEventHandler CountCallback;
		/// <summary>
		/// </summary>
		public delegate void CountEventHandler(BrickletRotaryEncoder sender, int count);

		/// <summary>
		/// </summary>
		public event CountEventHandler Count // for backward compatibility
		{
			add { CountCallback += value; }
			remove { CountCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletRotaryEncoder.SetCountCallbackThreshold"/> is reached.
		///  The parameter is the count of the encoder.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletRotaryEncoder.SetDebouncePeriod"/>.
		/// </summary>
		public event CountReachedEventHandler CountReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void CountReachedEventHandler(BrickletRotaryEncoder sender, int count);

		/// <summary>
		/// </summary>
		public event CountReachedEventHandler CountReached // for backward compatibility
		{
			add { CountReachedCallback += value; }
			remove { CountReachedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the button is pressed.
		/// </summary>
		public event PressedEventHandler PressedCallback;
		/// <summary>
		/// </summary>
		public delegate void PressedEventHandler(BrickletRotaryEncoder sender);

		/// <summary>
		/// </summary>
		public event PressedEventHandler Pressed // for backward compatibility
		{
			add { PressedCallback += value; }
			remove { PressedCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the button is released.
		/// </summary>
		public event ReleasedEventHandler ReleasedCallback;
		/// <summary>
		/// </summary>
		public delegate void ReleasedEventHandler(BrickletRotaryEncoder sender);

		/// <summary>
		/// </summary>
		public event ReleasedEventHandler Released // for backward compatibility
		{
			add { ReleasedCallback += value; }
			remove { ReleasedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletRotaryEncoder(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_COUNT] = new CallbackWrapper(OnCountCallback);
			callbackWrappers[CALLBACK_COUNT_REACHED] = new CallbackWrapper(OnCountReachedCallback);
			callbackWrappers[CALLBACK_PRESSED] = new CallbackWrapper(OnPressedCallback);
			callbackWrappers[CALLBACK_RELEASED] = new CallbackWrapper(OnReleasedCallback);


			responseExpected[FUNCTION_GET_COUNT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_COUNT_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_COUNT_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_COUNT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_COUNT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_IS_PRESSED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the current count of the encoder. If you set reset
		///  to true, the count is set back to 0 directly after the
		///  current count is read.
		///  
		///  The encoder has 24 steps per rotation
		///  
		///  Turning the encoder to the left decrements the counter,
		///  so a negative count is possible.
		/// </summary>
		public int GetCount(bool reset)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_COUNT);
			LEConverter.To((bool)reset, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletRotaryEncoder.CountCallback"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletRotaryEncoder.CountCallback"/> callback is only triggered if the count has changed since the
		///  last triggering.
		/// </summary>
		public void SetCountCallbackPeriod(long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_COUNT_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletRotaryEncoder.SetCountCallbackPeriod"/>.
		/// </summary>
		public long GetCountCallbackPeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_COUNT_CALLBACK_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletRotaryEncoder.CountReachedCallback"/> callback.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the count is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the count is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the count is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the count is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetCountCallbackThreshold(char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(17, FUNCTION_SET_COUNT_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((int)min, 9, request);
			LEConverter.To((int)max, 13, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletRotaryEncoder.SetCountCallbackThreshold"/>.
		/// </summary>
		public void GetCountCallbackThreshold(out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_COUNT_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.IntFrom(9, response);
			max = LEConverter.IntFrom(13, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletRotaryEncoder.CountReachedCallback"/>
		///  
		///  is triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletRotaryEncoder.SetCountCallbackThreshold"/>
		///  
		///  keeps being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletRotaryEncoder.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns *true* if the button is pressed and *false* otherwise.
		///  
		///  It is recommended to use the <see cref="Tinkerforge.BrickletRotaryEncoder.PressedCallback"/> and <see cref="Tinkerforge.BrickletRotaryEncoder.ReleasedCallback"/> callbacks
		///  to handle the button.
		/// </summary>
		public bool IsPressed()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_IS_PRESSED);

			byte[] response = SendRequest(request, 9);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnCountCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int count = LEConverter.IntFrom(8, response);
			var handler = CountCallback;

			if (handler != null)
			{
				handler(this, count);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnCountReachedCallback(byte[] response)
		{
			if (response.Length != 12)
			{
				return; // silently ignoring callback with wrong length
			}

			int count = LEConverter.IntFrom(8, response);
			var handler = CountReachedCallback;

			if (handler != null)
			{
				handler(this, count);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnPressedCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = PressedCallback;

			if (handler != null)
			{
				handler(this);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnReleasedCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = ReleasedCallback;

			if (handler != null)
			{
				handler(this);
			}
		}
	}
}
